"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const transporter_1 = require("../transporter");
const nock_1 = __importDefault(require("nock"));
require("cross-fetch/polyfill");
describe("EngineTransporter", () => {
    it("is a class", () => {
        expect(typeof transporter_1.EngineTransporter).toEqual("function");
    });
    it("perform a request", () => {
        const transporter = new transporter_1.EngineTransporter("http://localhost:9200", "my_engine", "apikey");
        const body = {
            query: {
                match_all: {}
            }
        };
        (0, nock_1.default)("http://localhost:9200", {
            reqheaders: {
                authorization: "ApiKey apikey"
            }
        })
            .post("/api/engines/my_engine/_search")
            .reply(200, () => ({
            hits: {
                hits: [
                    {
                        _id: "1",
                        _source: {
                            title: "My title"
                        }
                    }
                ]
            }
        }));
        return transporter
            .performRequest({
            body
        })
            .then((response) => {
            expect(response.hits.hits).toHaveLength(1);
            expect(response.hits.hits[0]._id).toEqual("1");
            expect(response.hits.hits[0]._source.title).toEqual("My title");
        });
    });
});
