import type { FieldConfiguration, Filter, FilterValue, FilterValueRange, QueryConfig, RequestState } from "@elastic/search-ui";
import { BaseFilters, SearchkitConfig } from "@searchkit/sdk";
export declare function getResultFields(resultFields: Record<string, FieldConfiguration>): {
    hitFields: string[];
    highlightFields: string[];
};
export declare function isValidDateString(dateString: unknown): boolean;
export declare function isRangeFilter(filterValue: FilterValue): filterValue is FilterValueRange;
export declare function buildBaseFilters(baseFilters: Filter[]): BaseFilters;
interface BuildConfigurationOptions {
    state: RequestState;
    queryConfig: QueryConfig;
}
declare function buildConfiguration({ state, queryConfig }: BuildConfigurationOptions): SearchkitConfig;
export default buildConfiguration;
