"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const search_1 = __importDefault(require("./handlers/search"));
const autocomplete_1 = __importDefault(require("./handlers/autocomplete"));
const transporter_1 = require("./handlers/transporter");
__exportStar(require("./types"), exports);
function isTransporter(config) {
    return config.performRequest !== undefined;
}
class EngineConnector {
    constructor(config) {
        this.config = config;
        if (isTransporter(config)) {
            this.transporter = config;
        }
        else {
            if (!config.host) {
                throw new Error("Engine Host must be provided.");
            }
            if (!config.engineName) {
                throw new Error("Engine Name must be provided.");
            }
            if (!config.apiKey) {
                throw new Error("API Key must be provided.");
            }
            const { host, engineName, apiKey } = config;
            this.transporter = new transporter_1.EngineTransporter(host, engineName, apiKey);
        }
    }
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    onResultClick() { }
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    onAutocompleteResultClick() { }
    onSearch(state, queryConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            return (0, search_1.default)({
                state,
                queryConfig,
                transporter: this.transporter
            });
        });
    }
    onAutocomplete(state, queryConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            return (0, autocomplete_1.default)({
                state,
                queryConfig,
                transporter: this.transporter
            });
        });
    }
}
exports.default = EngineConnector;
